// ComplexAgent.h: interface for the CComplexAgent class
//
///////////////////////////////////////////////////////////////////////////////

#ifndef __AFX_COMPLEXAGENT_H_
#define __AFX_COMPLEXAGENT_H_

#if _MSC_VER > 1000
#pragma once
#endif	// _MSC_VER > 1000

// ComplexAgent.h header file declares following classes

class CComplexAgent;

#include "BasicAgent.h"

#define POS_TOL			1.0		// default position tolerance in meters
#define TURN_TOL		20.0	// default turn tolerance in degrees
#define LOOK_TOL		10.0	// default look tolerance in degrees

///////////////////////////////////////////////////////////////////////////////
// Class: CComplexAgent
// Date: 16.04.01
// Version Date: 11.05.01
// Version: 1.05
// Author: Marek Lehuta
//
// Base Class: CBasicAgent
///////////////////////////////////////////////////////////////////////////////
// Description:
///////////////////////////////////////////////////////////////////////////////

class CComplexAgent : public CBasicAgent
{
// Construction
public:
	CComplexAgent();

// Attributes
protected:

// Operations
public:
	bool MoveAbs(const CPosition& pos, double dTol = POS_TOL);
//	void MoveRel(int x);		// move relative to the current position

//	int TurnAbs(int aNewAbsDir);
	void TurnRel(double dMoment);
	bool TurnToBall(double dTol = TURN_TOL);
	bool TurnToGoal(bool bOur = false, double dTol = TURN_TOL);
	bool TurnTo(const CPosition& pos, double dTol = TURN_TOL);

	bool LookAhead(double dTol = LOOK_TOL);
	bool LookAtBall(double dTol = LOOK_TOL);
	bool LookAtGoal(bool bOur = false, double dTol = LOOK_TOL);
	bool LookAt(const CPosition& pos, double dTol = LOOK_TOL);

//	void KickTo(const CPosition& pos);
	bool RunTo(const CPosition& destPos, bool bBackw = false, double dPosTol = POS_TOL, double dTurnTol = TURN_TOL);
	bool RunToLookingAt(const CPosition& destPos, const CPosition& lookPos, bool bBackw = false,
		double dPosTol = POS_TOL, double dTurnTol = TURN_TOL, double dLookTol = LOOK_TOL);

// Overrides
public:
	// main playing method
	virtual void Play();

	// ClassWizard generated virtual function overrides
public:
	//{{AFX_VIRTUAL(CComplexAgent)
	//}}AFX_VIRTUAL

// Message handlers
	// Generated message map functions
public:
	//{{AFX_MSG(CComplexAgent)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

// Implementation
public:
	virtual ~CComplexAgent();

};

///////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif	// __AFX_COMPLEXAGENT_H_
