// GoalieDoc.cpp: implementation of the CGoalieDoc class
//
///////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "Goalie.h"
#include "GoalieDoc.h"

#include "ConnectDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif	// _DEBUG

IMPLEMENT_DYNCREATE(CGoalieDoc, CDocument)

BEGIN_MESSAGE_MAP(CGoalieDoc, CDocument)
	//{{AFX_MSG_MAP(CGoalieDoc)
	ON_COMMAND(ID_APP_CONNECT, OnAppConnect)
	ON_UPDATE_COMMAND_UI(ID_APP_CONNECT, OnUpdateAppConnect)
	ON_COMMAND(ID_APP_DISCONNECT, OnAppDisconnect)
	ON_UPDATE_COMMAND_UI(ID_APP_DISCONNECT, OnUpdateAppDisconnect)
	ON_COMMAND(ID_VIEW_GRAPHICS, OnViewGraphics)
	ON_UPDATE_COMMAND_UI(ID_VIEW_GRAPHICS, OnUpdateViewGraphics)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

///////////////////////////////////////////////////////////////////////////////
// CGoalieDoc construction

CGoalieDoc::CGoalieDoc()
{
	m_bGraphics = true;
}

///////////////////////////////////////////////////////////////////////////////
// CGoalieDoc overrides

BOOL CGoalieDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument()) return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}

///////////////////////////////////////////////////////////////////////////////
// CGoalieDoc serialization

void CGoalieDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring()) {
		// TODO: add storing code here
	}
	else {
		// TODO: add loading code here
	}
}

///////////////////////////////////////////////////////////////////////////////
// CGoalieDoc message handlers

void CGoalieDoc::OnAppConnect()
{
	CConnectDlg connectDlg;

	// ask the user for the name of the team and the server
	connectDlg.m_strTeam = _T(DEFAULT_TEAM);
	connectDlg.m_strServer = _T(DEFAULT_SERVER);
	connectDlg.m_uPort = DEFAULT_PORT;
//	connectDlg.m_bGoalie = false;

	// user can repeat with a different address
	while(1) {
		if (connectDlg.DoModal() != IDOK) break;
		// try to connect
		if (m_goalie.ConnectAgent(connectDlg.m_strTeam, connectDlg.m_strServer, connectDlg.m_uPort, false)) break;
	}
}

void CGoalieDoc::OnUpdateAppConnect(CCmdUI* pCmdUI)
{
	if (m_goalie.IsConnected()) pCmdUI->Enable(FALSE);
	else pCmdUI->Enable(TRUE);
}

void CGoalieDoc::OnAppDisconnect()
{
	if (!m_goalie.IsConnected()) return;

	// close the socket
	m_goalie.DisconnectAgent();
}

void CGoalieDoc::OnUpdateAppDisconnect(CCmdUI* pCmdUI)
{
	if (m_goalie.IsConnected()) pCmdUI->Enable(TRUE);
	else pCmdUI->Enable(FALSE);
}

void CGoalieDoc::OnViewGraphics()
{
	m_bGraphics = !m_bGraphics;
	POSITION pos = GetFirstViewPosition();
	CView *pFirstView = GetNextView(pos);
	pFirstView->Invalidate();
}

void CGoalieDoc::OnUpdateViewGraphics(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(m_bGraphics);
}

///////////////////////////////////////////////////////////////////////////////
// CGoalieDoc implementation

CGoalieDoc::~CGoalieDoc()
{
}

///////////////////////////////////////////////////////////////////////////////
// CGoalieDoc diagnostics

#ifdef _DEBUG

void CGoalieDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CGoalieDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}

#endif	//_DEBUG
