// PlayerAgent.cpp: implementation of the CPlayerAgent class
//
///////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Goalie.h"
#include "PlayerAgent.h"

#include <math.h>
#include <stdio.h>
#include <stdlib.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif	// _DEBUG

// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CPlayerAgent, CComplexAgent)
	//{{AFX_MSG_MAP(CPlayerAgent)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

///////////////////////////////////////////////////////////////////////////////
// CPlayerAgent construction

CPlayerAgent::CPlayerAgent()
{
  m_pFile = fopen("ja.txt", "w");
//  m_pFile = NULL;
  m_Defenses = new CPosition[5];
  m_Offenses = new CPosition[5];
  m_Offenses[0].SetXY(40, 0);
  m_Offenses[1].SetXY(30, 28);
  m_Offenses[2].SetXY(30, -28);
  m_Offenses[3].SetXY(-10, 15);
  m_Offenses[4].SetXY(-10, -15);

  m_Defenses[0].SetXY(0, 0);
  m_Defenses[1].SetXY(-30, 28);
  m_Defenses[2].SetXY(-30, -28);
  m_Defenses[3].SetXY(-40, 10);
  m_Defenses[4].SetXY(-40, -10);

  m_perception.SetPlayerAgent(this);
  m_PrepareKick = 0;
  m_KickOff = 0;
  m_KickOffRun = 0;
  m_LookAround = 0;
}

///////////////////////////////////////////////////////////////////////////////
// CPlayerAgent operations

void CPlayerAgent::Play()
{
	// this is the main function for actions of the agent
	// to make the agent play, add your code here

	// call base class method
	CComplexAgent::Play();

  CPlayer* pPlayer = m_perception.GetAgentPlayer();
  CPlayer* pTeammate = NULL;

//	double dDir;

//  char tmpchar[100];
//  sprintf(tmpchar, "PlayMode = %d\n" ,m_perception.GetPlayMode());
//  TRACE(tmpchar);
//  sprintf(tmpchar, "PlaySide = %d\n" ,m_perception.GetAgentPlayer()->GetSide());
//  TRACE(tmpchar);

/*
  switch (m_perception.GetPlayMode()) {
    case PM_BEFORE_KICK_OFF:
          TRACE("PM_BEFORE_KICK_OFF");
          break;
    case PM_GOAL_R:         
          TRACE("PM_GOAL_R");
          break;
    case PM_GOAL_L:
          TRACE("PM_GOAL_L");
          break;
    case PM_KICK_OFF_L:
          TRACE("PM_KICK_OFF_L");
          break;
    case PM_GOAL_KICK_L:
          TRACE("PM_GOAL_KICK_L");
          break;
    case PM_KICK_IN_L:
          TRACE("PM_KICK_IN_L");
          break;
    case PM_FREE_KICK_L:
          TRACE("PM_FREE_KICK_L");
          break;
    case PM_CORNER_KICK_L:
          TRACE("PM_CORNER_KICK_L");
          break;
    case PM_KICK_OFF_R:
          TRACE("PM_KICK_OFF_R");
          break;
    case PM_GOAL_KICK_R:
          TRACE("PM_GOAL_KICK_R");
          break;
    case PM_KICK_IN_R:
          TRACE("PM_KICK_IN_R");
          break;
    case PM_FREE_KICK_R:
          TRACE("PM_FREE_KICK_R");
          break;
    case PM_CORNER_KICK_R:
          TRACE("PM_CORNER_KICK_R");
          break;
    case PM_PLAY_ON:
          TRACE("PM_PLAY_ON");
          break;
    case PM_TIME_OVER:
          TRACE("PM_TIME_OVER");
          break;
    default:
          TRACE("DEFAULT");
          break;
    }
*/
  if (m_PrepareKick > 0) m_PrepareKick++;
  if (m_PrepareKick > 2) m_PrepareKick = 0;
  if (m_KickOff > 0) m_KickOff++;
  if (m_KickOff > 5) m_KickOff = 0;
  if (m_LookAround > 0) m_LookAround++;
  if (m_LookAround > 4) m_LookAround = 0;

  if (m_LookAround == 3) {
      if (m_pFile) fprintf(m_pFile, "\tLooking around: right\n");
    TurnNeck(+170);
  }

  
  switch (m_perception.GetPlayMode()) {
    case PM_BEFORE_KICK_OFF:
          if (m_perception.GetSenseTime() == 0) {
            m_Score[0] = m_Score[1] = 0;
            if (m_perception.GetAgentPlayer()->GetSide() == SIDE_LEFT) {
              m_Switch = 1;
            } else {
              m_Switch = -1;
            }
          }
          GoToDefensePosition(TRUE);
          inGoal = FALSE;
    case PM_GOAL_R:         
          GoToDefensePosition(TRUE);
          if (!inGoal) {
            if (m_perception.GetAgentPlayer()->GetSide() == SIDE_LEFT) {
              m_Score[0]++;
            } else {
              m_Score[1]++;
            }
          }
          inGoal = TRUE;
          return;        
    case PM_GOAL_L:
          GoToDefensePosition(TRUE);
          if (!inGoal) {
            if (m_perception.GetAgentPlayer()->GetSide() == SIDE_RIGHT) {
              
              m_Score[0]++;
            } else {
              m_Score[1]++;
            }
          }
          inGoal = TRUE;
          return;        

    case PM_KICK_OFF_L:
    case PM_GOAL_KICK_L:
    case PM_KICK_IN_L:
    case PM_CORNER_KICK_L:
        inGoal = FALSE;
        if (m_perception.GetAgentPlayer()->GetSide() == SIDE_LEFT) {
          myTurn();          
        } else {
          opponentsTurn();          
        }
      return;
    case PM_FREE_KICK_L:
        inGoal = FALSE;
        if (m_perception.GetAgentPlayer()->GetSide() == SIDE_LEFT) {
          myTurnAtFreeKick();          
        } else {
          opponentsTurn();          
        }
      return;
    case PM_KICK_OFF_R:
    case PM_GOAL_KICK_R:
    case PM_KICK_IN_R:
    case PM_CORNER_KICK_R:
        inGoal = FALSE;
        if (m_perception.GetAgentPlayer()->GetSide() == SIDE_RIGHT) {
          myTurn();          
        } else {
          opponentsTurn();          
        }
        return;
    case PM_FREE_KICK_R:
        inGoal = FALSE;
        if (m_perception.GetAgentPlayer()->GetSide() == SIDE_RIGHT) {
          myTurnAtFreeKick();          
        } else {
          opponentsTurn();          
        }
        return;

    case PM_PLAY_ON:
        m_KickOffRun = 0;
        inGoal = FALSE;
        break;

    case PM_TIME_OVER:
    default:
        inGoal = FALSE;
        return;
    }

//return;
/*
  if (KnowBall() == FALSE) {
//    TRACE("Don't know where the ball is\n");
    if (m_pFile) fprintf(m_pFile, "\tDon't know where the ball is\n");
    SearchBall();
    m_nRunToBall = 0;
    }
  else {

    if (myBall() == TRUE) {
    
    
      if (m_PrepareKick < 2) {
        TRACE("Prepare kick\n");
        PrepareKick();
          return;
      }
      return;
      TRACE("Do kick\n");
      double dir = 0;
      if (m_perception.GetNearestOpponent() != NULL) dir = m_perception.GetAgentPlayer()->GetAngleTo(m_perception.GetNearestOpponent());
      Kick(100, dir);
    } else {
        RunToBall();

    }
  }
  return;
*/
  if (m_pFile) if (m_pFile) fprintf(m_pFile, "Time: %d\n", m_perception.GetSeeTime() > m_perception.GetSenseTime() ? m_perception.GetSeeTime() : m_perception.GetSenseTime());

  if (KnowBall() == FALSE) {
//    TRACE("Don't know where the ball is\n");
    if (m_pFile) fprintf(m_pFile, "\tDon't know where the ball is\n");
    SearchBall();
    m_nRunToBall = 0;
    }
  else {
    m_bSearchBall = false;
    if (myBall() == TRUE) {
      m_nRunToBall = 0;
      if (IsAbleToKick() == TRUE) {
//        TRACE("Kicking the ball to the goal\n");
        if (m_pFile) fprintf(m_pFile, "\tKicking the ball to the goal\n");
          Score();
        }
      else {
        if (IsOpponentNear() == TRUE) {
          CPlayer* pTeammate = NULL;
          if ((pTeammate = GetFreeTeammate()) != NULL) {
            //TRACE("Passing teammate\n");
            if (m_pFile) fprintf(m_pFile, "\tPassing teammate\n");
            PassBall(pTeammate);
            }
          else {
//            TryToFreeYourself();
            //TRACE("Freeing myself\n");
            if (m_pFile) fprintf(m_pFile, "\tFreeing myself\n");
            GoToGoal(); // must lead the ball - how can I do it?
/*
            CVector dir(1, m_perception.GetGoalDirection());
	        	Kick(100.0, dir.GetAngle());

*/
            }
          }
        else {
          CPlayer* pTeammate = NULL;
          if ((pTeammate = GetBetterPlacedTeammate()) != NULL) {
//            TRACE("Passing to better placed teammate\n");
            if (m_pFile) fprintf(m_pFile, "\tPassing to better placed teammate\n");
            PassBall(pTeammate);
            }
          else {
            //TRACE("Leading ball\n");
            if (m_pFile) fprintf(m_pFile, "\tLeading ball\n");
            GoToGoal(); // must lead the ball - how can I do it?
            }
          }
        }
      }
    else {
      // if I am the nearest player to the ball from our team, I go to the ball
      if (IsBallNearestFromTeam() == TRUE) {
//        TRACE("Running to the ball\n");
        if (m_pFile) fprintf(m_pFile, "\tRunning to the ball\n");
        m_nRunToBall |= 1;
        RunToBall();
        }
      else {
        m_nRunToBall = 0;
        // if our player is the nearest one to the ball, so we have the ball (a bit simplified)
        if (IsOurBall() == TRUE) {
//        TRACE("Going to offence position\n");
        if (m_pFile) fprintf(m_pFile, "\tGoing to offence position\n");
          GoToOffensePosition();
          }
        else {
//        TRACE("Going to defence position\n");
        if (m_pFile) fprintf(m_pFile, "\tGoing to defence position\n");
          GoToDefensePosition();  // here we should add chceking of opponents
          }
        }
      }
    }
//  if (m_pFile)
//    fclose(m_pFile);
}

///////////////////////////////////////////////////////////////////////////////
// CPlayerAgent implementation

CPlayerAgent::~CPlayerAgent()
{
  fclose(m_pFile);
  delete []m_Defenses;
  delete []m_Offenses;
}

BOOL CPlayerAgent::KnowBall()
{
  if (m_pFile) fprintf(m_pFile, "\tBall is old: %d\n", m_perception.GetBall()->GetAge());
	if (m_perception.GetBall()->IsValid() && m_perception.GetBall()->GetAge() < 8)
    return TRUE;
  else
    return FALSE;
/*
  CBall* pBall = m_perception.GetBall();
  int difTime = pBall->GetAge();
  if (difTime > 5)
    return FALSE;
  else
    return TRUE;
*/
}

BOOL CPlayerAgent::IsOurBall()
{
  CPlayer *pPlayer = m_perception.GetBallNearestPlayer();
  if (m_pFile) fprintf(m_pFile, "\tBall is %s our\n", m_perception.IsOurPlayer(pPlayer) ? "" : "not");
  return m_perception.IsOurPlayer(pPlayer);
/*
  CBall* pBall = m_perception.GetBall();
  int lastInfo = (pBall->GetOur()) * (100 - (pBall->GetAge()) * 10);
  int goingTo = 0;
  int goingFrom = 0;
  if (pBall->GetAge() < 3) {
    CPlayer *pClosest = m_perception.GetBallNearestPlayer();
    if (pClosest) {
      goingTo = 40 * (m_perception.IsOurPlayer(pClosest) ? 1 : -1);
      pBall->SetOur(m_perception.IsOurPlayer(pClosest) ? 1 : -1);
      }
    else {
      goingTo = 40;
      pBall->SetOur(1);
      }
    }
  if (lastInfo + goingTo + goingFrom > 0)
    return TRUE;
  else
    return FALSE;
*/
}

BOOL CPlayerAgent::myBall()
{
/*
  int leadBall = m_nLeadBall * (100 - (m_perception.GetSeeTime() - m_nLeadTime) * 15);
  int nearBall = m_perception.GetBallNearestPlayer() == m_perception.GetAgentPlayer() ? 1 : 0;
  if (nearBall > 0) {
    if ((m_perception.GetAgentPlayer()->GetAbsPos() - m_perception.GetBall()->GetAbsPos()).GetLength() < 1)
      return TRUE;
    else
      return FALSE;
    }
  else
    return FALSE;
*/
  if (m_pFile) fprintf(m_pFile, "\tI am %f meters from ball\n", m_perception.GetBallDistance());
	if (m_perception.GetBallDistance() < MY_BALL)
    return TRUE;
  else
    return FALSE;
}

BOOL CPlayerAgent::IsOpponentNear()
{
  CPlayer *pThisPlayer = m_perception.GetAgentPlayer();
  CPlayer *pRival = m_perception.GetNearestOpponent(pThisPlayer);
  if (pRival == NULL) {
    if (m_pFile) fprintf(m_pFile, "\tThere is no opponent I know\n");
    return FALSE;
    }
  if (m_pFile) fprintf(m_pFile, "\tNearest opponent is at %f meters from me\n", (pRival->GetAbsPos() - pThisPlayer->GetAbsPos()).GetLength());
  if ((pRival->GetAbsPos() - pThisPlayer->GetAbsPos()).GetLength() < 5)
    return TRUE;
  else
    return FALSE;
}

BOOL CPlayerAgent::IsAbleToKick()
{
  double dist = m_perception.GetGoalDistance();
  if (m_pFile) fprintf(m_pFile, "\tI am %f meters from goal\n", m_perception.GetGoalDistance());
  double maxDist= m_perception.EvaluateBallDistance(100);
  if (dist * 3 < maxDist * 2)
    return TRUE;
  else
    return FALSE;
}

void CPlayerAgent::kickGoal()
{
  if (m_pFile) fprintf(m_pFile, "\tKicking at goal\n");
  Kick(100, m_perception.GetGoalDirection());
}

void CPlayerAgent::PassBall(CPlayer *pTeammate)
{
  ASSERT(pTeammate != NULL);
  CPlayer *pPlayer = m_perception.GetAgentPlayer();
  if (m_pFile) fprintf(m_pFile, "\tPassing to teammate\n");
  if (m_pFile) fprintf(m_pFile, "\tI'm at %d:%d, he is at %d:%d, i'm heading to %f, I'm kicking to %f, %f\n",
    (int)pPlayer->GetAbsX(), (int)pPlayer->GetAbsY(), (int)pTeammate->GetAbsX(), (int)pTeammate->GetAbsY(),
    pPlayer->GetBodyDir(), pTeammate->GetDirection(), pPlayer->GetAngleTo(pTeammate));

  Kick(m_perception.EvaluatePower(pPlayer->GetDistanceTo(pTeammate) + 10), pPlayer->GetAngleTo(pTeammate));
}

CPlayer *CPlayerAgent::GetBetterPlacedTeammate()
{
  if (m_pFile) fprintf(m_pFile, "\tFinding better placed teammate\n");
  return m_perception.GetBetterPlacedTeammate();
}

void CPlayerAgent::GoToGoal()
{
  CPlayer *pPlayer = m_perception.GetAgentPlayer();
  if (m_pFile) fprintf(m_pFile, "\tGoing to goal\n", m_perception.GetGoalDistance());

  double maxDist= m_perception.EvaluateBallDistance(100);
  double dGoalDir = m_perception.GetGoalDirection();
  double lAng = dGoalDir + 50.0;
  double rAng = dGoalDir - 50.0;
  double freedir = m_perception.GetFreeDirection(lAng, rAng); //avoids kicking towards opponent
  double power = 100;

  if (m_perception.IsInPenaltyArea() || maxDist <= -32.0 - pPlayer->GetAbsX() * m_Switch) {
    KickToCorner();
    return;
  }
  if (dGoalDir < -90.0 || dGoalDir > 90.0) {
      power = 100;
      double dev = (pPlayer->GetAbsY() * m_Switch < 0.0) ? 30.0 : -30.0;
      //if (maxDist > 12) {
          CVector vect(1, dGoalDir + dev);
          freedir = vect.GetAngle();
        //} else {
           //freedir = 0.0;
           //power = m_perception.EvaluatePower(2);
        //}
  } else {
    CPlayer *opp = m_perception.GetNearestOpponent(pPlayer, freedir, 60.0);
    CPlayer *opp2 = m_perception.GetNearestOpponent(pPlayer);
    double power = 100;
    if (opp != NULL) {
      power = m_perception.EvaluatePower(pPlayer->GetDistanceTo(opp)/2-3);
    } else {
      power = m_perception.EvaluatePower(15);
    }
    if (power > 100 || power == 0) power = 100;
  }

  Kick(power, freedir);
//  TRACE("Do kick\n");
//  Kick(100, freedir);
//  Kick(100, m_perception.GetGoalDirection());
}

BOOL CPlayerAgent::comingBall()
{
  CPlayer *pThisPlayer = m_perception.GetAgentPlayer();
//  CBall *pBall = m_perception.GetBall();
//  CVector myBallVector = pThisPlayer->GetAbsPos() - pBall->GetAbsPos();

  if (m_perception.GetBallNearestPlayer() == pThisPlayer) {
    if (m_pFile) fprintf(m_pFile, "\tI am ball nearest player\n");
    return TRUE;
    }
  else {
    if (m_pFile) fprintf(m_pFile, "\tI am not ball nearest player\n");
//  TVector meBallVector(pMe->GetAbsX() - pBall->GetAbsX(), pMe->GetAbsY() - pBall->GetAbsY());
/*
  int meBall = GetAngle(meBallVector);
  TVector ballVector = pBall->GetAbsSpeed();
  int ball = GetAngle(ballVector);
  if ((abs(meBall - ball) + 10) % 180 < 20 && pMe->GetDistanceTo(pBall) < MAX_BALL_DIST)
    return TRUE;
  else
... */
    return FALSE;
    }
}

void CPlayerAgent::receiveBall()
{
  CPosition receivePos = m_perception.GetBallInterceptPos(m_perception.GetAgentPlayer());
  if (m_pFile) fprintf(m_pFile, "\tReceiving ball - position: %f:%f\n", receivePos.GetX(), receivePos.GetY());
  RunTo(receivePos);
}

void CPlayerAgent::GoToOffensePosition(bool move)
{
  if (m_pFile) fprintf(m_pFile, "\tRunning to offense position\n");
  CPlayer *pThisPlayer = m_perception.GetAgentPlayer();

  if (move) {
    CPosition pos(m_Defense.GetX() / 2.0, m_Defense.GetY() / 2.0);
    if (pos.GetX() > -13.0 && pos.GetY() > -13.0 && pos.GetY() < 13.0) pos.SetX(-13.0);
    if (pThisPlayer->GetDistanceTo(pos) > 0) {
      Move(pos.GetX(), pos.GetY() * m_Switch);
    }
  } else {
    if (m_perception.GetPlayMode() == PM_KICK_OFF_L || m_perception.GetPlayMode() == PM_KICK_OFF_R || m_perception.GetPlayMode() == PM_GOAL_KICK_L|| m_perception.GetPlayMode() == PM_GOAL_KICK_R) {
      if (KnowBall() == FALSE) {
        SearchBall();
        return;
      }
    }
    CPosition ballPos(m_Switch * m_perception.GetBall()->GetAbsPos().GetX(), m_perception.GetBall()->GetAbsPos().GetY());
    CPosition pos((m_Offense.GetX() + ballPos.GetX()) / 2.0 * m_Switch, (m_Offense.GetY() + ballPos.GetY()) / 2.0);

    CVector positionVector(pos.GetX() - pThisPlayer->GetAbsX(), pos.GetY() - pThisPlayer->GetAbsY());
    double positionAngle = positionVector.GetAngle();
    double ballAngle = m_perception.GetBallDirection();
    if (fabs(positionAngle - ballAngle) > 100)
      RunTo(pos, true);
    else
      RunTo(pos);
    LookAtBall();
  }
}

void CPlayerAgent::GoToDefensePosition(bool move)
{
  if (m_pFile) fprintf(m_pFile, "\tRunning to defense position\n");
  CPlayer *pThisPlayer = m_perception.GetAgentPlayer();

  if (move) {
    CPosition pos(m_Defense.GetX() / 2.0, m_Defense.GetY() / 2.0);
    if (pos.GetX() > -13.0 && pos.GetY() > -13.0 && pos.GetY() < 13.0) pos.SetX(-13.0);
    if (pThisPlayer->GetDistanceTo(pos) > 0) {
      Move(pos.GetX(), pos.GetY() * m_Switch);
    }
  } else {
    if (m_perception.GetPlayMode() == PM_KICK_OFF_L || m_perception.GetPlayMode() == PM_KICK_OFF_R || m_perception.GetPlayMode() == PM_GOAL_KICK_L|| m_perception.GetPlayMode() == PM_GOAL_KICK_R) {
      if (KnowBall() == FALSE) {
        SearchBall();
        return;
      }
    }
    CPosition ballPos(m_Switch * m_perception.GetBall()->GetAbsPos().GetX(), m_perception.GetBall()->GetAbsPos().GetY());
    CPosition pos((m_Defense.GetX() + ballPos.GetX()) / 2.0 * m_Switch, (m_Defense.GetY() + ballPos.GetY()) / 2.0);

    CVector positionVector(pos.GetX() - pThisPlayer->GetAbsX(), pos.GetY() - pThisPlayer->GetAbsY());
    double positionAngle = positionVector.GetAngle();
    double ballAngle = m_perception.GetBallDirection();
    if (fabs(positionAngle - ballAngle) > 100)
      RunTo(pos, true);
    else
      RunTo(pos);
    LookAtBall();
  }
}

BOOL CPlayerAgent::defensePos()
{
  CPlayer *pThisPlayer = m_perception.GetAgentPlayer();
  CPlayer *pNearestRival = m_perception.GetNearestOpponent(pThisPlayer);
  
  if (pNearestRival == NULL) return FALSE;
  if (pThisPlayer->GetDistanceTo(pNearestRival) > MAX_DEFENSED_OPPONENT_DIST)
    return FALSE;
  double angle = int(fabs(pNearestRival->GetDirection() - m_perception.GetGoal()[1].GetDirection()) + 10) % 180;
  if (angle < 20)
    return TRUE;
  return FALSE;
}

BOOL CPlayerAgent::IsBallNearestFromTeam()
{
  CPlayer *pThisPlayer = m_perception.GetAgentPlayer();
  if (m_perception.GetBallNearestTeammate() == pThisPlayer) {
    if (m_pFile) fprintf(m_pFile, "\tI am the nearest man from team to the ball\n");
    return TRUE;
    }
  else {
    if (m_pFile) fprintf(m_pFile, "\tI am not the nearest man from team to the ball\n");
    return FALSE;
    }
}

void CPlayerAgent::runBall()
{
  CPlayer *pThisPlayer = m_perception.GetAgentPlayer();
  RunTo(m_perception.GetBallInterceptPos(pThisPlayer));
}

void CPlayerAgent::defenseRun()
{
  CPlayer *pThisPlayer = m_perception.GetAgentPlayer();
  CPlayer *pNearestRival = m_perception.GetNearestOpponent(pThisPlayer);
  
  double dx = m_perception.GetBall()->GetAbsX() - pNearestRival->GetAbsX();
  double dy = m_perception.GetBall()->GetAbsY() - pNearestRival->GetAbsY();

  double size = sqrt(dx * dx + dy * dy);
  double x = double(dx) / size * 5;
  double y = double(dy) / size * 5;

  CPosition pos(pNearestRival->GetAbsX() + x, pNearestRival->GetAbsY() + y);
  RunTo(pos);
}

BOOL CPlayerAgent::freeRival()
{
  CPlayer *pThisPlayer = m_perception.GetAgentPlayer();
  CPlayer *pNearestRival = m_perception.GetNearestOpponent(pThisPlayer);

	int i;
	double mindist, dist;
	CPlayer *pAgent, *pMinAgent;

	CPosition pos0 = pNearestRival->GetAbsPos();

	pMinAgent = NULL;  mindist = 10000.0;
  for (i = 0; i < 11; i++) {
		pAgent = m_perception.GetTeammates()[i];
    if (pAgent->GetAge() < 3) {
			dist = (pAgent->GetAbsPos() - pos0).GetLength();
			if (mindist > dist) {
				mindist = dist;
				pMinAgent = pAgent;
			  }
		  }
	  }
  if (pAgent == pThisPlayer)
    return TRUE;
  else
    return FALSE;
}

BOOL CPlayerAgent::myPlace()
{
  CPlayer *pThisPlayer = m_perception.GetAgentPlayer();
  CPosition position = pThisPlayer->GetAbsPos();
  if (m_Defense.GetX() - 2 < position.GetX() && m_Defense.GetX() + 2 > position.GetX())
    if (m_Defense.GetY() - 2 < position.GetY() && m_Defense.GetY() + 2 > position.GetY())
      return TRUE;
  return FALSE;
}

void CPlayerAgent::searchRival()
{
  CPlayer *pThisPlayer = m_perception.GetAgentPlayer();
  CPlayer *pNearestRival = m_perception.GetNearestOpponent(pThisPlayer);
  RunTo(pNearestRival->GetAbsPos());
}

void CPlayerAgent::placeRun()
{
  RunTo(m_Defense);
}

BOOL CPlayerAgent::timeBall()
{
  return TRUE;
}

void CPlayerAgent::SearchBall()
{
  CPlayer *pPlayer = m_perception.GetAgentPlayer();
  if (fabs(pPlayer->GetHeadDir()) > 5.0) LookAhead();
  if (m_bSearchBall == false) {
  	Turn(m_perception.GetBallDirection());
    }
  else 
    Turn(45);
  m_bSearchBall |= true;
//  Turn(90);
}

void CPlayerAgent::lookBall()
{

}

CPlayer *CPlayerAgent::GetFreeTeammate()
{
  if (m_pFile) fprintf(m_pFile, "\tI am finding free teammate\n");
  CPlayer *pPlayer;
  CPlayer *pBestPlayer = NULL;
  CPlayer *pThisPlayer = m_perception.GetAgentPlayer();
  double dBestPlayerDistance = 1000;
  for (int i = 0; i < 11; i++) {
		pPlayer = m_perception.GetTeammates()[i];
    if (pPlayer == NULL) continue;
    if (pPlayer->IsValid() == false) continue;
    if (pPlayer->GetDistance() > MAX_TEAMMATE_DIST) continue;
    CPlayer *pPlayerOpponent = m_perception.GetNearestOpponent(pPlayer);
    if (pPlayerOpponent == NULL || pBestPlayer == NULL) {
      pBestPlayer = pPlayer;
      dBestPlayerDistance = 1000;
      }
    else {
      double dDistance = pPlayer->GetDistanceTo(pPlayerOpponent);
      if (dDistance < dBestPlayerDistance) {
        pBestPlayer = pPlayer;
        dBestPlayerDistance = dDistance;
        }
      }
  	}
  if (dBestPlayerDistance < CRITICAL_DISTANCE)
    return NULL;
  else
    return pBestPlayer;
}

void CPlayerAgent::SetPlayer(int nType)
{
  CString str;
  str.Format("I am %d player", nType);
  AfxMessageBox(str);
  m_Offense = m_Offenses[nType];
  m_Defense = m_Defenses[nType];
}

void CPlayerAgent::RunToBall()
{
  // if the player is close to the ball and there's is no opponent near, so look right and left to
  // find some teammates
//  double dDir;
  CPlayer *pPlayer = m_perception.GetAgentPlayer();
/*
  if (fabs((dDir = (m_perception.GetBallInterceptPos(pPlayer) - pPlayer->GetAbsPos() - pPlayer->GetBodyDir()).GetAngle())) > 10.0) {
	  Turn(dDir);
    }
  else {
	  Dash(100);
    }
*/
  RunTo(m_perception.GetBallInterceptPos(pPlayer));

/*  
  CPlayer *pOpponent = m_perception.GetNearestOpponent(pPlayer);
  double dist = CRITICAL_DISTANCE;
  if (pOpponent) 
    dist = m_perception.GetBallInterceptTime(pPlayer);
  bool lookAround = false;
  if (dist < CRITICAL_DISTANCE && dist > 1 && m_perception.GetBall()->IsValid()) {
    double dir = pPlayer->GetHeadDir();
    if (pPlayer->GetHeadDir() == -45 && m_nRunToBall < m_perception.GetSeeTime()) {
      m_nRunToBall = m_perception.GetSeeTime();
      if (m_pFile) fprintf(m_pFile, "\tLooking around: right\n");
      lookAround = true;
      TurnNeck(90);
      }
    else if (pPlayer->GetHeadDir() == 45 && m_nRunToBall < m_perception.GetSeeTime()) {
      m_nRunToBall = m_perception.GetSeeTime();
      if (m_pFile) fprintf(m_pFile, "\tLooking around: finished\n");
      TurnNeck(-45);
      lookAround = true;
      }
    else if (m_perception.GetBallDistance() < 6 && m_nRunToBall == 1) {
      m_nRunToBall = m_perception.GetSeeTime();
      if (m_pFile) fprintf(m_pFile, "\tLooking around: left\n");
      TurnNeck(-45 - pPlayer->GetHeadDir());
      lookAround = true;
      }
    else
      lookAround = false;
    }
  if (lookAround == false)
	  if (fabs(m_perception.GetBallDirection() - pPlayer->GetHeadDir()) > 10.0) LookAtBall();


  */

  
  CPlayer *pOpponent = m_perception.GetNearestOpponent(pPlayer);
  double dist = CRITICAL_DISTANCE-1;
  if (pOpponent) 
    dist = m_perception.GetBallInterceptTime(pPlayer);
  if (m_LookAround == 0 && dist < CRITICAL_DISTANCE && dist > 1 && m_perception.GetBall()->IsValid()) {
    double dir = pPlayer->GetHeadDir();
    if (m_perception.GetBallDistance() < 6 && m_nRunToBall == 1) {
      m_nRunToBall = m_perception.GetSeeTime();
      if (m_pFile) fprintf(m_pFile, "\tLooking around: left\n");
      TurnNeck(-85 - pPlayer->GetHeadDir());
      m_LookAround = 1;
    }
  }

  if (m_LookAround == 0) {
	  if (fabs(m_perception.GetBallDirection() - pPlayer->GetHeadDir()) > 10.0) LookAtBall();
    if (m_pFile) fprintf(m_pFile, "\tLooking at the ball\n");
  }


  }

void CPlayerAgent::Score()
{
	CPosition midPoint = m_perception.GetGoal()->GetAbsPos();
  CPosition post1(midPoint.GetX(), midPoint.GetY() - GOAL_WIDTH/2.0);
  CPosition post2(midPoint.GetX(), midPoint.GetY() + GOAL_WIDTH/2.0);
  double ang1 = m_perception.GetAgentPlayer()->GetAngleTo(post1);
  double ang2 = m_perception.GetAgentPlayer()->GetAngleTo(post2);
  double lAng;
  double rAng;
  if (m_perception.GetAgentPlayer()->GetSide() == SIDE_RIGHT) {
    lAng = ang1;
    rAng = ang2;
  } else {
    lAng = ang2;
    rAng = ang1;
  }
  
 	Kick(100.0, m_perception.GetFreeDirection(lAng, rAng));

}

void CPlayerAgent::myTurn()
{
  CPlayer* pPlayer = m_perception.GetAgentPlayer();
  CPlayer* pTeammate;

  if (KnowBall() == FALSE) {
    SearchBall();
    return;
    }
  double dAngle = m_perception.GetGoalDirection(), dPower = 100.0;
  if (m_perception.GetPlayMode() == PM_GOAL_KICK_L || m_perception.GetPlayMode() == PM_GOAL_KICK_R) {
    dPower = m_perception.EvaluatePower(8.0);

  } else if (m_perception.GetPlayMode() == PM_KICK_OFF_L || m_perception.GetPlayMode() == PM_KICK_OFF_R) {// || m_perception.GetPlayMode() == PM_GOAL_KICK_L|| m_perception.GetPlayMode() == PM_GOAL_KICK_R 
      switch (m_KickOff) {
      case 1: TurnToGoal(TRUE);return;
      case 5: PassBall(m_perception.GetNearestTeammateTo(m_perception.GetGoal(TRUE)->GetAbsPos()));return;
    }
    dAngle = pPlayer->GetAngleTo(m_perception.GetGoal(TRUE));
  } else {
    dAngle = m_perception.GetFreeDirection(dAngle + 60.0, dAngle - 60.0);
  }

  if (m_perception.GetBallNearestTeammate() == pPlayer) {
    if (m_KickOffRun == 0) {
      //double dx = -5, dy = 0;
      //if (m_perception.GetBall()->GetAbsX() > 0);
      CPosition tmpPos(m_perception.GetBall()->GetAbsX() - 5 * m_Switch, m_perception.GetBall()->GetAbsY());
      //CPosition middle(0,0);
      //CPosition tmpPos2(
      if (pPlayer->GetDistanceTo(tmpPos) < 1) {
        m_KickOffRun++;
        return;
      }
      RunTo(tmpPos);
      return;
    } else {
      if (myBall()) {
        if ((pTeammate = GetFreeTeammate()) != NULL) {
          PassBall(pTeammate);
        } else {
  	     	Kick(dPower, dAngle);
        }
      } else {
        runBall();
      }
    }
  } else {
    GoToOffensePosition();
  }
}

void CPlayerAgent::opponentsTurn()
{
  if (KnowBall() == FALSE) {
    SearchBall();
    return;
  }
  GoToDefensePosition();

}

void CPlayerAgent::myTurnAtFreeKick()
{
  if (KnowBall() == FALSE) {
    SearchBall();
    return;
  }
  GoToOffensePosition();

}

void CPlayerAgent::PrepareKick()
{
  m_PrepareKick++;
  CPlayer* pPlayer = m_perception.GetAgentPlayer();
//  CVector vect(1, pPlayer->GetAngleTo(m_perception.GetBall()));
  CVector vect(1, m_perception.GetBall()->GetSpeedDir());
  vect.Rotate(180);
  Kick(20, vect.GetAngle());
}

void CPlayerAgent::KickToCorner()
{
  CPlayer* pPlayer = m_perception.GetAgentPlayer();
  double y = 37.0, x = -52.5 * m_Switch;
  if (pPlayer->GetAbsY() < 0) y = -y;
  CPosition pos(x, y);
  Kick(100, pPlayer->GetAngleTo(pos));
  TRACE("kicking to corner");
  if (m_pFile) fprintf(m_pFile, "\tkicking to corner\n");
}
