// PlayerAgent.h: interface for the CPlayerAgent class
//
///////////////////////////////////////////////////////////////////////////////

#ifndef __AFX_PLAYERAGENT_H_
#define __AFX_PLAYERAGENT_H_

#if _MSC_VER > 1000
#pragma once
#endif	// _MSC_VER > 1000

// PlayerAgent.h header file declares following classes

class CPlayerAgent;

#include "ComplexAgent.h"

#define MIN_KICK_DIST 18
#define MY_BALL (KICKABLE_MARGIN + PLAYER_SIZE + BALL_SIZE)
#define MAX_BALL_DIST     10.0
#define MAX_DEFENSED_OPPONENT_DIST     5.0
#define CRITICAL_DISTANCE 5.0

///////////////////////////////////////////////////////////////////////////////
// Class: CPlayerAgent
// Date: 16.04.01
// Version Date: 28.04.01
// Version: 1.05
// Author: Marek Lehuta
//
// Base Class: CComplexAgent
///////////////////////////////////////////////////////////////////////////////
// Description:
///////////////////////////////////////////////////////////////////////////////

class CPlayerAgent : public CComplexAgent
{
// Construction
public:
	CPlayerAgent();
  FILE *m_pFile;

// Attributes
protected:
  int m_nRunToBall;
  bool m_bSearchBall;
// Operations
public:
	void Play();

protected:
	CPlayer *GetFreeTeammate();
	void lookBall();
	void SearchBall();
	BOOL timeBall();
	void placeRun();
	void searchRival();
	BOOL myPlace();
	BOOL freeRival();
	void defenseRun();
	void runBall();
	BOOL IsBallNearestFromTeam();
	BOOL defensePos();
	void GoToOffensePosition(bool move = false);
	void GoToDefensePosition(bool move = false);
	void receiveBall();
	BOOL comingBall();
	void GoToGoal();
	CPlayer *GetBetterPlacedTeammate();
	void PassBall(CPlayer *pTeammate);
	void kickGoal();
	BOOL IsAbleToKick();
	BOOL IsOpponentNear();
	BOOL myBall();
	BOOL IsOurBall();
	BOOL KnowBall();
  void RunToBall();
	void Score();

  CPosition *m_Defenses;
  CPosition *m_Offenses;
  
  CPosition m_Defense;
  CPosition m_Offense;

  int m_Score[2];
  bool inGoal;
  int m_Switch;
  int m_KickOff;
  int m_KickOffRun;
  int m_PrepareKick;
  int m_LookAround;
  // Overrides
	// ClassWizard generated virtual function overrides
public:
	//{{AFX_VIRTUAL(CPlayerAgent)
	//}}AFX_VIRTUAL

// Message handlers
	// Generated message map functions
public:
	//{{AFX_MSG(CPlayerAgent)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

// Implementation
public:
  int GetSwitch(void) {return m_Switch;};
	void KickToCorner(void);
	void PrepareKick(void);
	void opponentsTurn(void);
	void myTurn(void);
  void myTurnAtFreeKick(void);
	void SetPlayer(int nType);
	virtual ~CPlayerAgent();

};

///////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif	// __AFX_PLAYERAGENT_H_
