// Position.cpp: implementation of the CPosition class
//
///////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "Goalie.h"
#include "Position.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#endif	// _DEBUG

///////////////////////////////////////////////////////////////////////////////
// CPosition operations

CPosition CPosition::operator+(const CVector& vect) const
{
	return CPosition(m_dX + vect.GetX(), m_dY + vect.GetY());
}

CPosition CPosition::operator-(const CVector& vect) const
{
	return CPosition(m_dX - vect.GetX(), m_dY - vect.GetY());
}

CVector CPosition::operator-(const CPosition& pos) const
{
	return CVector(m_dX - pos.GetX(), m_dY - pos.GetY(), 0);
}

bool CPosition::operator==(const CPosition& pos) const
{
	return (m_dX == pos.GetX() && m_dY == pos.GetY());
}

const CPosition& CPosition::operator=(const CPosition& pos)
{
	m_dX = pos.GetX();
	m_dY = pos.GetY();
	return *this;
}

const CPosition& CPosition::operator+=(const CVector& vect)
{
	m_dX += vect.GetX();
	m_dY += vect.GetY();
	return *this;
}

const CPosition& CPosition::operator-=(const CVector& vect)
{
	m_dX -= vect.GetX();
	m_dY -= vect.GetY();
	return *this;
}
