// SocketAgent.cpp: implementation of the CSocketAgent class
//
///////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "Goalie.h"
#include "SocketAgent.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif	// _DEBUG

//IMPLEMENT_DYNAMIC(CSocketAgent, CAsyncSocket)

// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CSocketAgent, CAsyncSocket)
	//{{AFX_MSG_MAP(CSocketAgent)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

///////////////////////////////////////////////////////////////////////////////
// CSocketAgent construction

CSocketAgent::CSocketAgent()
{
	memset(&m_sockAddr, 0, sizeof(m_sockAddr));
	m_uSockPort = 0;
	m_strSockAddr = _T("");
	m_bSockConnected = false;
}

///////////////////////////////////////////////////////////////////////////////
// CSocketAgent operations

BOOL CSocketAgent::Create(unsigned uSockPort, LPCTSTR psSockAddr)
{
	int iSocketType = SOCK_DGRAM;
	long lEvent = FD_READ | FD_WRITE | FD_ACCEPT | FD_CONNECT | FD_CLOSE;

	m_bSockConnected = false;
	// create the socket
	if (Socket(iSocketType, lEvent)) {
		// try to bind the socket to any address
		if (Bind(uSockPort, psSockAddr)) return TRUE;

		// an error occured
		int iResult = GetLastError();
		Close();
		WSASetLastError(iResult);
	}
	return FALSE;
}

BOOL CSocketAgent::Bind(unsigned uSockPort, LPCTSTR psSockAddr)
{
	int	iResult;

	// bind to INADDR_ANY
	memset(&m_sockAddr, 0, sizeof(m_sockAddr));
	m_sockAddr.sin_family = AF_INET;
	m_sockAddr.sin_addr.s_addr = htonl(INADDR_ANY);
	m_sockAddr.sin_port = htons(0);
	iResult = CAsyncSocket::Bind((SOCKADDR*)&m_sockAddr, sizeof(m_sockAddr));

	// set the proper values of port and address for the following SendTo command
	memset(&m_sockAddr, 0, sizeof(m_sockAddr));
	LPSTR psAscii = (LPTSTR)psSockAddr;
	m_sockAddr.sin_family = AF_INET;
	m_sockAddr.sin_addr.s_addr = inet_addr(psAscii);
	if (m_sockAddr.sin_addr.s_addr == INADDR_NONE) {
		// get the address from a nameserver
		LPHOSTENT pHost;
		pHost = gethostbyname(psAscii);
		if (pHost != NULL) m_sockAddr.sin_addr.s_addr = ((LPIN_ADDR)pHost->h_addr)->s_addr;
		else {
			WSASetLastError(WSAEINVAL);
			return FALSE;
		}
	}
	m_sockAddr.sin_port = htons(uSockPort);

	// return the result of the Bind command
	return iResult;
}

BOOL CSocketAgent::Connect()
{
	m_bSockConnected = true;
	return CAsyncSocket::Connect((SOCKADDR*)&m_sockAddr, sizeof(m_sockAddr));
}

int CSocketAgent::ReceiveData(void* pBuf, int iBufLen)
{
	int iResult;

	if (m_bSockConnected) iResult = Receive(pBuf, iBufLen);
	else {
		// try to receive data
		memset(&m_sockAddr, 0, sizeof(m_sockAddr));
		int iSockAddrLen = sizeof(m_sockAddr);
		iResult = CAsyncSocket::ReceiveFrom(pBuf, iBufLen, (SOCKADDR*)&m_sockAddr, &iSockAddrLen);
		if (iResult != SOCKET_ERROR) {
			// succesfull
			m_uSockPort = ntohs(m_sockAddr.sin_port);
			m_strSockAddr = inet_ntoa(m_sockAddr.sin_addr);
			Connect();
		}
	}

	return iResult;
}

int CSocketAgent::SendData(const void* pBuf, int iBufLen)
{
	if (m_bSockConnected) return Send(pBuf, iBufLen);
	else return CAsyncSocket::SendTo(pBuf, iBufLen, (SOCKADDR*)&m_sockAddr, sizeof(m_sockAddr));
}

/////////////////////////////////////////////////////////////////////////////
// CSocketAgent overrides

void CSocketAgent::OnReceive(int nErrorCode)
{
	CAsyncSocket::OnReceive(nErrorCode);
}
