// SocketAgent.h: interface for the CSocketAgent class
//
///////////////////////////////////////////////////////////////////////////////

#ifndef __AFX_SOCKETAGENT_H_
#define __AFX_SOCKETAGENT_H_

#if _MSC_VER > 1000
#pragma once
#endif	// _MSC_VER > 1000

// SocketAgent.h header file declares following classes

class CSocketAgent;

///////////////////////////////////////////////////////////////////////////////
// Class: CSocketAgent
// Date: 13.04.01
// Version Date: 19.04.01
// Version: 1.01
// Author: Marek Lehuta
//
// Base Class: CAsyncSocket
///////////////////////////////////////////////////////////////////////////////
// Description: socket class for SoccerServer communication
//				because server creates new socket for each player connected and
//				sends it back in first datagram, CAsyncSocket could not be used
//				as it was but had to be changed in the methods listed here
///////////////////////////////////////////////////////////////////////////////

class CSocketAgent : public CAsyncSocket
{
//	DECLARE_DYNAMIC(CSocketAgent);
// Construction
public:
	CSocketAgent();

// Attributes
private:
	SOCKADDR_IN m_sockAddr;
	unsigned m_uSockPort;
	CString m_strSockAddr;
	bool m_bSockConnected;

// Operations
public:
	// functions from CAsyncsocket adapted for this use
	BOOL Create(unsigned uSockPort, LPCTSTR psSockAddr);
	BOOL Bind(unsigned uSockPort, LPCTSTR psSockAddr);
	BOOL Connect();
	int ReceiveData(void* pBuf, int iBufLen);
	int SendData(const void* pBuf, int iBufLen);

	// get and set functions
	void SetPort(unsigned uPort) { m_uSockPort = uPort; };
	unsigned GetPort() const { return m_uSockPort; };
	CString GetAddress() const { return m_strSockAddr; };

// Overrides
	// ClassWizard generated virtual function overrides
public:
	//{{AFX_VIRTUAL(CSocketAgent)
	virtual void OnReceive(int nErrorCode);
	//}}AFX_VIRTUAL

// Message handlers
	// Generated message map functions
public:
	//{{AFX_MSG(CSocketAgent)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

// Implementation
public:
	virtual ~CSocketAgent() {};

};

///////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif	// __AFX_SOCKETAGENT_H_
